mod Ex07c

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Mxpr

incl Maux

loc rem 
  \para \bf  7. CVIČENIE Z PREDMETU 2-AIN-266 DEKLARATÍVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end pondelok 21.3.2022 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/2-AIN-266-dp/2122ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované obecne 
  rekurzívnym funkciam a efektívnym operáciam na primitívne rekurzívnych 
  indexoch. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor \it  mxpr.cl  \end obsahuje aritmetizáciu p.r. 
         funkčných symbolov. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 5 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 2 
  \end
  \para Odovzdať do 2.4.2022 (sobota) do 18:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/3 Tex3_appl_sb_dotsc
  Prefix(90,2,Arg(0),
         Fenced(Op('[',0),Infix(Arg(1),30,3,Id(1,',...,',0),Arg(2)),Op(']',0)))

appldisp/0 Tex_f0_m
  Std('m',0)

rem 
  \para \bf  Section. General Recursive Functions.  \end 

rem 
  \para \bf  Section. Beyond Primitive Recursion: Universal Function for 
  Primitive Recursive Functions.  \end 

rem 
  \para \bf  Subsection. Arithmetization.  \end. 

rem 
  \para \bf  Arithmetization of primitive recursive function symbols.  \end See 
  also the module \it  Mxpr  \end. 

rem 
  \para \bf  Interpreter of primitive recursive function symbols.  \end 

fun/2 Interpreter 'Tex_f2_xpr_interpreter'
  Interpreter(Zx,x) = 0
  Interpreter(Sx,x) = x+1
  Interpreter(Ix(n,i),x) = Proj(n,x,i)
  Interpreter(Px(g,gs),x) = Interpreter(g,x),Interpreter(gs,x)
  Interpreter(Cx(n,m,h,gs),x) = Interpreter(h,Interpreter(gs,x))
  Interpreter(Rx(n,g,h),0,y) = Interpreter(g,y)
  Interpreter(Rx(n,g,h),x+1,y) = Interpreter(h,x,Interpreter(Rx(n,g,h),x,y),y)

rem 
  \para \bf  Subsection. Primitive Recursive Indices.  \end 

rem 
  \para \bf  Subsubsection. Effective Operations on Primitive Recursive Indices. 
   \end 

rem 
  \para \bf  Exercise.  \end \header* fun Xc1 'Tex_f1_xpr_xc1' \end Define the 
  p.r. function \ft Xc1(m) \end such that 
  \eq* 
    Prf(1,Xc1(m))
  \end
  \eq* 
    Interpreter(Xc1(m),x) = m
  \end

fun Xc1 'Tex_f1_xpr_xc1'
  Xc1(m) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/2 Xc2 'Tex_f2_xpr_xc2' \end Define the binary p.r. function 
  \ft Xc2(n,m) \end such that for every \ft n >= 1 \end: 
  \eq* 
    Prf(n,Xc2(n,m))
  \end
  \eq* 
    Interpreter(Xc2(n,m),x1,Tex0_dotsc,Tex2_sub(x,n)) = m
  \end

fun/2 Xc2 'Tex_f2_xpr_xc2'
  Xc2(n,m) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Xiter 'Tex_f1_xpr_xiter' \end Define a 
  p.r. function \ft Xiter(e) \end such that 
  \eq* 
    Prf(1,e) -> Prf(2,Xiter(e))
  \end
  \eq* 
    Interpreter(Xiter(e),0,x) = x
  \end
  \eq* 
    Interpreter(Xiter(e),n+1,x) = Interpreter(e,Interpreter(Xiter(e),n,x))
  \end
  \para This means that if \ft e \end is a p.r. index of a unary function then 
  \ft Xiter(e) \end is a p.r. index of its unary iteration. 

fun Xiter 'Tex_f1_xpr_xiter'
  Xiter(e) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Find a well-formed p.r. index 
  of \ft x+y \end which corresponds to the p.r. derivation of addition as an 
  iteration of the successor function. Define the index with the help of 
  \ft Xiter(e) \end. 

fun/0 Xplus 'Tex_f0_xpr_xplus'
  Xplus = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xrec0 'Tex_f2_xpr_xrec0' \end Define 
  a p.r. function \ft Xrec0(m,e) \end such that 
  \eq* 
    Prf(2,e) -> Prf(1,Xrec0(m,e))
  \end
  \eq* 
    Interpreter(Xrec0(m,e),0) = m
  \end
  \eq* 
    Interpreter(Xrec0(m,e),x+1) = Interpreter(e,x,Interpreter(Xrec0(m,e),x))
  \end
  \para \header* fun F 'Tex_f1_f' \end \header* fun/2 H1 'Tex_f2_h' \end 
  \header* fun/0 M1 'Tex_f0_m' \end This means that if \ft M1 \end is a constant 
  and \ft e \end is a p.r. index of a binary function \ft H1(x,a) \end then 
  \ft Xrec0(m,e) \end is a p.r. index of the unary function \ft F(x) \end 
  defined by following parameterless primitive recursion: 
  \def 
    fun F 'Tex_f1_f'
    F(0) = M1
    F(x+1) = H1(x,F(x))
  \end

fun/2 Xrec0 'Tex_f2_xpr_xrec0'
  Xrec0(m,e) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end 
  \header* fun/0 Xsum 'Tex_f0_xpr_xsum' \end Find a well-formed p.r. index of 
  \ft Sum(n) \end which corresponds to the derivation of the summation function 
  by parameterless recursion. Define the index with the help of 
  \ft Xrec0(m,e) \end. 

fun/0 Xsum 'Tex_f0_xpr_xsum'
  Xsum = Foo

rem 
  \para \bf  Exercise.  \end Find a well-formed p.r. index of \ft x-1 \end which 
  corresponds to the derivation of the predecessor function by parameterless 
  recursion. Define the index with the help of \ft Xrec0(m,e) \end. 

fun/0 Xpred 'Tex_f0_xpr_xpred'
  Xpred = Foo

rem 
  \para \bf  Exercise. \it  (2 points)  \end  \end Find a well-formed p.r. index 
  of \ft x-y \end which corresponds to the p.r. derivation of modified 
  subtraction as an iteration of the predecessor function. Define the index with 
  the help of \ft Xiter(e) \end. 

fun/0 Xminus 'Tex_f0_xpr_xminus'
  Xminus = Foo

rem 
  \para \bf  Exercise.  \end \header* fun/2 Xparam 'Tex_f2_xpr_xparam' \end 
  Define the binary \it  parametric  \end function \ft Xparam(e,x) \end such 
  that 
  \eq* 
    Prf(2,e) -> Prf(1,Xparam(e,x))
  \end
  \eq* 
    Interpreter(Xparam(e,x),y) = Interpreter(e,x,y)
  \end
  \para as a p.r. function. 

fun/2 Xparam 'Tex_f2_xpr_xparam'
  Xparam(e,x) = Foo

rem 
  \para \bf  Exercise. \it  (bonus 2 points)  \end  \end 
  \header* fun/3 Xsmn_2_3 'Tex_f3_xpr_xsmn_2_3' \end Prove the \it  Kleene's 
  s-m-n theorem  \end for the case \ft m = 2 \end and \ft n = 3 \end by 
  providing a ternary p.r. function \ft Xsmn_2_3(e,x1,x2) \end such that 
  \eq* 
    Prf(5,e) -> Prf(3,Xsmn_2_3(e,x1,x2))
  \end
  \eq* 
    Interpreter(Xsmn_2_3(e,x1,x2),y1,y2,y3) = Interpreter(e,x1,x2,y1,y2,y3)
  \end

fun/3 Xsmn_2_3 'Tex_f3_xpr_xsmn_2_3'
  Xsmn_2_3(e,x1,x2) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

